.\"
.\"	File: dc20ctrl.man
.\"
.\"	Copyright (C) 1998 Ugo Paternostro <paterno@dsi.unifi.it>
.\"
.\"	This file is part of the dc20ctrl package. The complete package can be
.\"	downloaded from:
.\"	    http://aguirre.dsi.unifi.it/~paterno/binaries/dc20ctrl.tar.gz
.\"
.\"	This package is derived from the dc20 package, built by Karl Hakimian
.\"	<hakimian@aha.com> that you can find it at ftp.eecs.wsu.edu in the
.\"	/pub/hakimian directory. The complete URL is:
.\"	    ftp://ftp.eecs.wsu.edu/pub/hakimian/dc20.tar.gz
.\"
.\"	This package also includes a sligthly modified version of the Comet to ppm
.\"	conversion routine written by YOSHIDA Hideki <hideki@yk.rim.or.jp>
.\"
.\"	This program is free software; you can redistribute it and/or modify
.\"	it under the terms of the GNU General Public License as published 
.\"	the Free Software Foundation; either version 2 of the License, or
.\"	(at your option) any later version.
.\"
.\"	This program is distributed in the hope that it will be useful,
.\"	but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"	GNU General Public License for more details.
.\"
.\"	You should have received a copy of the GNU General Public License
.\"	along with this program; if not, write to the Free Software
.\"	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.\"	Manual page for the dc20ctrl program
.\"
.\"	$Id: dc20ctrl.man,v 1.3 1998/02/18 10:32:11 ugo Exp $
.\"
.\" -*- nroff -*-
.TH DC20CTRL 1 "18 Feb 1998" "Version 0.4"
.SH NAME
dc20ctrl \- controls the Kodak DC20 digital camera.
.SH SYNOPSIS
.B dc20ctrl \-V
.P
.B dc20ctrl
[
.B \-b
.I baud_rate
]
[
.B \-e
[
.B \-f
]
]
[
.B \-h
|
.B \-l
|
.B \-r
]
[
.B \-i
]
[
[
.B \-p
[
.B \-P
.I pictures_base_name
]
[
{
.B \-w
|
.B \-c
}
[
.B \-R
.I red_factor
]
[
.B \-G
.I green_factor
]
[
.B \-B
.I blue_factor
]
[
.B \-S
.I saturation
]
[
.B \-g
.I gamma
]
[
.B \-L
.I low_i
]
[
.B \-H
.I high_i
]
[
.B \-a
]
[
.B \-k
]
]
[
.B \-t
[
.B \-T
.I thumbnails_base_name
]
]
[
.B \-n
.I pictures
]
[
.B \-j
[
.B \-Q
.I jpeg_quality
]
]
[
.B \-F
[
.B \-C
.I compression[:option]
]
]
[
.B \-N
]
]
[
.B \-q
|
.B \-v
]
[
.B \-s
]
[
.I device_name
]
.P
.B dc20ctrl \-o
[
{
.B \-w
|
.B \-c
}
[
.B \-R
.I red_factor
]
[
.B \-G
.I green_factor
]
[
.B \-B
.I blue_factor
]
[
.B \-S
.I saturation
]
[
.B \-g
.I gamma
]
[
.B \-L
.I low_i
]
[
.B \-H
.I high_i
]
[
.B \-a
]
[
.B \-k
]
]
[
.B \-n
.I pictures
]
[
.B \-j
[
.B \-Q
.I jpeg_quality
]
]
[
.B \-F
[
.B \-C
.I compression[:option]
]
]
[
.B \-N
]
.I file_1
[ ...  [
.I file_16
]
]
.SH DESCRIPTION
.B dc20ctrl 
can control your Kodak DC20 digital camera via the embedded serial port. You
need a cable that plugs into a serial port of your computer and into the jack
on the camera. Look at
.I http://home.t-online.de/home/Oliver.Hartmann/dc20prot.htm
if you need to build your cable.
.PP
With
.B dc20ctrl
you can control any parameter of your camera, as quering the current state,
taking a photo, downloading the thumbnails and/or the pictures (in raw,
.B pgm(5)
or
.B ppm(5)
format, and eventually others: it depends on compilation-time options), erasing
the camera memory and changing its resolution.
.PP
With the first synopsis, the program just prints the version number and exits
without doing anything else.
.PP
The second synopsis allow you to download picture(s) and convert them online,
or to control the camera via the serial port. Please note that
.B dc20ctrl
will at first get all pictures and then convert them, so you may save a bit
the battery life. Well, it really depends on how fast is your computer
converting the pictures, you know :-) In this case,
.B device_name
is the path of the device to use to talk to the camera. By default,
.I /dev/cuaa0
is assumed if you are working under FreeBSD, otherwise
.I /dev/ttyR1
is used.
.PP
In this mode,
.B dc20ctrl
will keep a session counter used to name pictures and thumbnails to avoid
accidentally overwriting existing files. The counter will be kept in the
.I .dc20ctrlrc
file in the current directory or in your home directory. Please note that
.B dc20ctrl
will
.B NOT
create the file in the current directory if it does not exist, but it will
create the one in your home directory instead. If you want to keep a separate
session number for the current directory, create an empty file with the
.B touch(1)
command.
.PP
The last synopsis is useful to convert raw (Comet) files in greyscale or
24 bit colors format in offline mode. You may specify up to 16 Comet files at
once.
.PP
By default,
.B dc20ctrl
saves the images in raw (Comet) format. You can later convert this format to
.B ppm(5)
using
.B dc20ctrl
itself, or
.B cmttoppm
by Yoshida Hideki <hideki@yk.rim.or.jp>.
.SH OPTIONS
.TP
.I \-a
Resize the image to fix aspect ratio. This is needed because the CCD cells are
not square. This option will work only if you specify
.B \-c
or
.B \-w
options too.
.TP
.I \-b baud_rate
Specifies the baud rate that will be used to talk to the camera. You can use
one of 9600, 19200, 38400, 57600 and 115200, the latter being the default.
.TP
.I \-B blue_factor
Specify the correction parameter of blue for the
.B ppm(5)
conversion routine. The default value is 1.00. An higher value will make the
colour stronger. This option will work only if you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-c
Save the photo in 24 bit colour format. This option will work only if you
specify
.B \-p
option too, and is mutually exclusive with the
.B \-w
option.
.TP
.I \-C compression[:option]
Use this option to change the compression scheme of TIFF files.
.B Compression
may be one between
.I j
(JPEG compression),
.I p
(PackBits compression),
.I l
(LZW compression),
.I z
or .I d
(Deflate compression). Any other character will switch to no compresison (the
default). For JPEG compression, you may specify a compression level, 90 being
the default. For LZW and Deflate compression, you may specify a predictor value,
zero being the default.
.TP
.I \-e
Erases all the images for the camera memory. You will be prompetd for confirmation, unless you specify also the
.B \-f
option.
.TP
.I \-f
Forces the delete to happen without asking for confirmation. To be used with
.B \-e
option.
.TP
.I \-F
Save the images (photo or thumbnails) in TIFF format. This option may be
missing due to compilation-time options. Please note that you must use also
one between
.B \-c
or
.B \-w
if you want to save photo's in TIFF format. This is not true for thumbnails.
You may change the TIFF compression mode using the
.B \-C
option. By default, no compression is used.
.TP
.I \-g gamma
Specify the gamma parameter for the
.B ppm(5)
conversion routine. The default value is 0.35. A smaller value makes a higher
contrast. This option will work only if you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-G green_factor
Specify the correction parameter of green for the
.B ppm(5)
conversion routine. The default value is 0.58. An higher value will make the
colour stronger. This option will work only if you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-h
Set the camera in high resolution mode. You can switch resolution only if
the memory is empty.
.TP
.I \-H high_i
Specify the upper bound for the
.B ppm(5)
conversion routine. The default value is -1. This option will work only if
you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-i
Prints information on the machine status, like the modem name, the firmware
version, the free memory, the mode and the battery status.
.TP
.I \-j
Save the images (photo or thumbnails) in JPEG format. This option may be
missing due to compilation-time options. Please note that you must use also
one between
.B \-c
or
.B \-w
if you want to save photo's in JPEG format. This is not true for thumbnails.
You may change the JPEG compression factor using the
.B \-Q
option.
.TP
.I \-k
Keep raw (Comet) files after the conversion to 24 bit colour or greyscale. By
default
.B dc20ctrl
will delete the raw files as soon as it converts them. Use
.B \-k
to prevent this. This option will work only if you specify
.B \-c
or
.B \-w
options too.
.TP
.I \-l
Set the camera in low resolution mode. You can switch resolution only if
the memory is empty.
.TP
.I \-L low_i
Specify the lower bound for the
.B ppm(5)
conversion routine. The default value is -1. This option will work only if
you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-n range_1 [ ,... [ ,range_n ] ]
Selects the pictures on which both
.B \-p
and
.B \-t
will operate and the direction of rotation for each picture. You can specify
one or more ranges, where a
.B range
can be:

.I [default_orientation:]photo_number[this_photo_orientation]

or

.I [default_orientation:]first_photo_number-last_photo_number[this_set_orientation]

where the
.B orientation
is a letter between
.I s
(straight),
.I l
(left, or +90 degrees),
.I r
(right, or -90 degrees) and
.l b
(bottom-up, or 180 degrees), and
.I photo_number
is a number between 1 and 16. If you want to specify a set of photo's, use two
numbers separated by an hyphen. If you specify a default orientation, that will
be the rotation applied to all ranges from the current one to the end of the
string. Please note that the default orientation
.B must
be followed by a colon. If you specify an orientation for the current photo or
the current set, that will apply only for those. You may specify more ranges,
where each range is separated from the preceding one by a comma.

If you do not use the
.B \-n
option, by default the
.B \-p
and
.B \-t
options will operate on all pictures currently in the camera memory, with
straight orientation.
.TP
.I \-N
Save the images (photo or thumbnails) in PNG format. This option may be
missing due to compilation-time options. Please note that you must use also
one between
.B \-c
or
.B \-w
if you want to save photo's in PNG format. This is not true for thumbnails.
.TP
.I \-o
Offline operation mode. In this mode,
.B dc20ctrl
will convert up to 16 Comet file (supplied on the command line), as they where
just downloaded from the camera. This can be useful for many reasons, one being
that the Comet format is the only really lossless format you can use. The same
options as with
.B \-p
apply here, but
.B \-P.
Infact, the destination files will have the same name as the source files, but
with different extension, depending on the output format selected.
.TP
.I \-p
Extracts photo's from the camera memory. By default, extracts all the photo's
naming them
.I pic_YYYY_MM_DD_S_N.EXT,
where
.I YYYY
is the year number,
.I MM
is the month number (with leading zero),
.I DD
is the day number (with leading zero),
.I S
is the session number,
.I N
is the photo number, starting from 1 and increasing for each photo, and
.I EXT
is the extension related to the file type: it can be
.I cmt
for Comet raw files,
.I pgm
for
.B pgm(5)
greyscale images or
.I ppm
for
.B ppm(5)
24 bit color images. If you, at compilation time, included support for JPEG,
TIFF or PNG file formats,
it can be also
.I jpg, tif
or
.I png.
You can select which photo's to extract using the
.B \-n
option, and change the file names using the
.B \-P
option.
.TP
.I \-P pictures_base_name
Change the name of the files that will contain the photo's. If you supply a 
string here, the file name for pictures will become
.I SSSSSS_N.EXT,
where
.I SSSSSS
is the string you supplied and
.I N
and
.I EXT
are the same as above.
.TP
.I \-q
Quiet operation: suppress
.B all
error messages.
.TP
.I \-Q quality
Change the quality for JPEG encoding. Please note that this option may be
missing due to compile-time options. This option is useless without
.B \-j
option.
.TP
.I \-r
Switch the camera resolution mode, between high and low resolution. You can
switch resolution only if the memory is empty.
.TP
.I \-R red_factor
Specify the correction parameter of red for the
.B ppm(5)
conversion routine. The default value is 0.64. An higher value will make the
colour stronger. This option will work only if you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-s
Take (shoot) a photo. This will work only if there is enough free memory in the
camera. The photo will be taken before changing resolution, if you asked to.
.TP
.I \-S saturation
Specify the correction parameter of saturation for the
.B ppm(5)
conversion routine. The default value is 1.00. An higher value will make all
the colours louder. This option will work only if you specify the
.B \-c
or
.B \-w
options too.
.TP
.I \-t
Extracts thumbnails from the camera memory. By default, extracts all the
thumbnails naming them
.I thumb_YYYY_MM_DD_S_N.EXT.
The same conventions as in
.B \-p
switch apply here. Please seee above.  You can select which thumbnails to
extract using the
.B \-n
option, and can change the file names using the
.B \-T
option.
.TP
.I \-T thumbnails_base_name
Change the name of the files that will contain the thumbnails. See
.B \-P
switch.
.TP
.I \-v
Verbose operation: magnify the output level.
.TP
.I \-w
Save the photo in
.B pgm(5)
format. This option will work only if you specify
.B \-p
option too, and is mutually exclusive with the
.B \-c
option.
.SH EXAMPLES
To use a different baud rate and serial port:
.PP
    dc20ctrl -b 38400 /dev/cuaa1
.PP
To take a photo, use:
.PP
    dc20ctrl -s
.PP
To erase all photo's without confirmation:
.PP
    dc20ctrl -ef
.PP
To download all thumbnails , use:
.PP
    dc20ctrl -t
.PP
To download all images in raw (Comet) format, use
.PP
    dc20ctrl -p
.PP
while, to download only images 1, 3, and from 5 to 7 use
.PP
    dc20ctrl -pn 1,3,5-7
.PP
To download all images in
.B pgm(5)
format:
.PP
    dc20ctrl -pw
.PP
To downloads all images in
.B ppm(5)
format:
.PP
    dc20ctrl -pc
.PP
Add the
.B \-a
switch to have the correct aspect ratio in photo's, like in:
.PP
    dc20ctrl -pca
.PP
To download image number 4, rotating it to the rigth before saving in JPEG:
.PP
    dc20ctrl -pcajn 4r
.PP
To download all images, rotating all them to the left but image 6, and saving
in PNG format:
.PP
    dc20ctrl -pcaNn l:1-5,6s,7-16
.PP
or
.PP
    dc20ctrl -pcaNn l:1-16,6s
.PP
To convert a bunch of
.B .cmt
files to TIFF format, without deleting them:
.PP
    dc20ctrl -okcaF *.cmt
.PP
Finally, to take a photo, download it in
.B ppm(5)
format and then erase all camera memory without confirmation, use:
.PP
    dc20ctrl -spcaef
.PP
this command may be used in a script file to take a photo in an automatic way,
for example to monitor a room.
.SH FILES
\&./.dc20ctrlrc - Current directory session counter.

~/.dc20ctrlrc - Global session counter.
.El
.SH SEE ALSO
touch(1), pgm(5), ppm(5)
.SH LEGAL MUMBO-JUMBO
Copyright (C) 1998 Ugo Paternostro <paterno@dsi.unifi.it>
.PP
I am in no way connected to Kodak (Eastman Kodak), nor I belong to their
"developer support program".
.PP
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
.PP
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
.PP
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.SH AUTHOR
Ugo Paternostro <paterno@dsi.unifi.it> wrote
.B dc20ctrl
starting for the
.B dc20
project of Karl Hakimian <hakimian@eecs.wsu.edu>
.PP
Yoshida Hideki <hideki@yk.rim.or.jp> wrote the
.B cmttoppm
conversion routine.
.SH BUGS
There may be some.  Please, report them to the author.
.SH AVAILABILITY
The last version of
.B dc20ctrl
is available into my WWW home page (http://aguirre.dsi.unifi.it/~paterno)
as http://aguirre.dsi.unifi.it/~paterno/binaries/dc20ctrl.tar.gz
